﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class CS : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            this.BindGrid();
        }
    }

    private void BindGrid()
    {
        using (CustomersDataContext ctx = new CustomersDataContext())
        {
            GridView1.DataSource = from customer in ctx.Customers
                                   select customer;
            GridView1.DataBind();
        }
    }

protected void Insert(object sender, EventArgs e)
{
    using (CustomersDataContext ctx = new CustomersDataContext())
    {
        Customer customer = new Customer
        {
            Name = txtName.Text,
            Country = txtCountry.Text
        };
        ctx.Customers.InsertOnSubmit(customer);
        ctx.SubmitChanges();
    }

    this.BindGrid();
}

    protected void OnRowEditing(object sender, GridViewEditEventArgs e)
    {
        GridView1.EditIndex = e.NewEditIndex;
        this.BindGrid();
    }

    protected void OnRowCancelingEdit(object sender, EventArgs e)
    {
        GridView1.EditIndex = -1;
        this.BindGrid();
    }

protected void OnRowUpdating(object sender, GridViewUpdateEventArgs e)
{
    GridViewRow row = GridView1.Rows[e.RowIndex];
    int customerId = Convert.ToInt32(GridView1.DataKeys[e.RowIndex].Values[0]);
    string name = (row.FindControl("txtName") as TextBox).Text;
    string country = (row.FindControl("txtCountry") as TextBox).Text;
    using (CustomersDataContext ctx = new CustomersDataContext())
    {
        Customer customer = (from c in ctx.Customers
                                where c.CustomerId == customerId
                                select c).FirstOrDefault();
        customer.Name = name;
        customer.Country = country;
        ctx.SubmitChanges();
    }
    GridView1.EditIndex = -1;
    this.BindGrid();
}

    protected void OnRowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow && e.Row.RowIndex != GridView1.EditIndex)
        {
            (e.Row.Cells[2].Controls[2] as LinkButton).Attributes["onclick"] = "return confirm('Do you want to delete this row?');";
        }
    }

protected void OnRowDeleting(object sender, GridViewDeleteEventArgs e)
{
    int customerId = Convert.ToInt32(GridView1.DataKeys[e.RowIndex].Values[0]);
    using (CustomersDataContext ctx = new CustomersDataContext())
    {
        Customer customer = (from c in ctx.Customers
                                where c.CustomerId == customerId
                                select c).FirstOrDefault();
        ctx.Customers.DeleteOnSubmit(customer);
        ctx.SubmitChanges();
    }
    this.BindGrid();
}
}